'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _watch_plugin;









function _load_watch_plugin() {return _watch_plugin = _interopRequireDefault(require('../watch_plugin'));}var _jestUtil;
function _load_jestUtil() {return _jestUtil = require('jest-util');}var _snapshot_interactive_mode;
function _load_snapshot_interactive_mode() {return _snapshot_interactive_mode = _interopRequireDefault(require('../snapshot_interactive_mode'));}function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

class UpdateSnapshotInteractivePlugin extends (_watch_plugin || _load_watch_plugin()).default {



  constructor(options)


  {
    super(options);
    this._snapshotInteractiveMode = new (_snapshot_interactive_mode || _load_snapshot_interactive_mode()).default(this._stdout);
  }

  registerHooks(hooks) {
    hooks.testRunComplete(results => {
      this._failedSnapshotTestPaths = (0, (_jestUtil || _load_jestUtil()).getFailedSnapshotTests)(results);
      if (this._snapshotInteractiveMode.isActive()) {
        this._snapshotInteractiveMode.updateWithResults(results);
      }
    });
  }

  onData(key) {
    if (this._snapshotInteractiveMode.isActive()) {
      this._snapshotInteractiveMode.put(key);
    }
  }

  showPrompt(
  globalConfig,
  updateConfigAndRun)
  {
    if (this._failedSnapshotTestPaths.length) {
      return new Promise(res => {
        this._snapshotInteractiveMode.run(
        this._failedSnapshotTestPaths,
        (path, shouldUpdateSnapshot) => {
          updateConfigAndRun({
            testNamePattern: '',
            testPathPattern: path,
            updateSnapshot: shouldUpdateSnapshot ? 'all' : 'none' });

          if (!this._snapshotInteractiveMode.isActive()) {
            res();
          }
        });

      });
    } else {
      return Promise.resolve();
    }
  }

  getUsageRow(globalConfig) {
    return {
      hide:
      !this._failedSnapshotTestPaths ||
      this._failedSnapshotTestPaths.length === 0,
      key: 'i'.codePointAt(0),
      prompt: 'update failing snapshots interactively' };

  }} /**
      * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      *
      * 
      */exports.default = UpdateSnapshotInteractivePlugin;